apiVersion: {{ sts_apivers }}
kind: StatefulSet
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ alertmanager_name }}
  name: {{ alertmanager_name }}
  namespace: {{ namespace }}
spec:
  podManagementPolicy: OrderedReady
  replicas: {{ alertmanager_replicas }}
  selector:
    matchLabels:
      name: {{ alertmanager_name }}
  serviceName: {{ alertmanager_name }}
  template:
    metadata:
      labels:
        name: {{ alertmanager_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ alertmanager_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ alertmanager_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - args:
        - --config.file=/etc/config/alertmanager.yml
        - --cluster.listen-address=$(POD_IP):6783
{% for n in range(alertmanager_replicas | int) %}
        - --cluster.peer={{ alertmanager_name }}-{{ loop.index0 }}.{{ alertmanager_name }}.{{ namespace }}.svc.{{ cluster_domain }}:6783
{% endfor %}
{% if do_debugs %}
        - --log.level=debug
{% endif %}
        - --storage.path=/data
        - --web.external-url=https://{{ alertmanager_fqdn }}
        - --web.listen-address=:9093
        - --web.route-prefix=/
        env:
        - name: POD_IP
          valueFrom:
            fieldRef:
              fieldPath: status.podIP
        - name: TZ
          value: {{ timezone }}
        image: {{ (opsimages | json_query("[?name=='alertmanager'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 20
{% else %}
          failureThreshold: 5
{% endif %}
          initialDelaySeconds: 30
          periodSeconds: 30
          tcpSocket:
            port: 9093
        name: alertmanager
        ports:
        - containerPort: 6783
          name: mesh
        - containerPort: 9093
          name: http
        readinessProbe:
          httpGet:
            path: /#/status
            port: 9093
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 3
        resources:
          limits:
            cpu: "{{ alertmanager_cpu_limit }}"
            memory: "{{ alertmanager_memory_limit }}"
          requests:
            cpu: "{{ alertmanager_cpu_request }}"
            memory: "{{ alertmanager_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 70
          initialDelaySeconds: 10
          periodSeconds: 15
          tcpSocket:
            port: 9093
{% endif %}
        volumeMounts:
{% if not (smtp_relay | default(False)) and smtps_address | default(False) %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /data
          name: data
        - mountPath: /etc/config/alertmanager.yml
          name: config
          subPath: alertmanager.yml
{% if notify_teams_address | default(False) %}
      - env:
        - name: TEAMS_INCOMING_WEBHOOK_URL
          valueFrom:
            secretKeyRef:
              key: teams-url
              name: {{ alertmanager_name }}
        - name: TEAMS_REQUEST_URI
          value: alertmanager
        image: {{ (opsimages | json_query("[?name=='teamsproxy'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          initialDelaySeconds: 30
          periodSeconds: 30
          tcpSocket:
            port: 2000
          timeoutSeconds: 25
        name: teamsproxy
        ports:
        - containerPort: 2000
        readinessProbe:
          initialDelaySeconds: 30
          httpGet:
            path: /metrics
            port: 2000
          periodSeconds: 30
          timeoutSeconds: 20
        resources:
          limits:
            cpu: "{{ teamsproxy_cpu_limit }}"
            memory: "{{ teamsproxy_memory_limit }}"
          requests:
            cpu: "{{ teamsproxy_cpu_request }}"
            memory: "{{ teamsproxy_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% endif %}
{% if alertmanager_do_lemon or alertmanager_do_ldap %}
      - env:
        - name: AUTH_METHOD
{% if alertmanager_do_lemon %}
          value: oidc
{% else %}
          value: ldap
{% endif %}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
{% if alertmanager_do_lemon %}
          value: /oauth2/callback
        - name: OIDC_CLIENT_ID
          value: alertmanager
        - name: OIDC_CLIENT_SECRET
          valueFrom:
            secretKeyRef:
              key: alertmanager-oauth2-secret
              name: {{ ldap_secret_name }}
        - name: OIDC_CRYPTO_SECRET
          valueFrom:
            secretKeyRef:
              key: oidc-crypto-secret
              name: {{ alertmanager_name }}
        - name: OIDC_META_URL
          value: /.well-known/openid-configuration
        - name: OIDC_PORTAL
          value: {{ lemon_portal }}
        - name: OIDC_TOKEN_ENDPOINT_AUTH
          value: client_secret_basic
{% else %}
          value: ""
        - name: OIDC_CLIENT_ID
          value: ""
        - name: OIDC_CLIENT_SECRET
          value: ""
        - name: OIDC_CRYPTO_SECRET
          value: ""
        - name: OIDC_META_URL
          value: ""
        - name: OIDC_PORTAL
          value: ""
        - name: OIDC_TOKEN_ENDPOINT_AUTH
          value: ""
{% endif %}
        - name: OPENLDAP_BASE
{% if alertmanager_do_lemon %}
          value: ""
        - name: OPENLDAP_BIND_DN_PREFIX
          value: ""
        - name: OPENLDAP_BIND_PW
          value: ""
        - name: OPENLDAP_DOMAIN
          value: ""
        - name: OPENLDAP_HOST
          value: ""
        - name: OPENLDAP_PORT
          value: ""
        - name: OPENLDAP_PROTO
          value: ""
        - name: OPENLDAP_USERS_OBJECTCLASS
          value: ""
        - name: PING_PATH
          value: /ping
{% else %}
          valueFrom:
            secretKeyRef:
              key: directory-root
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_BIND_DN_PREFIX
          value: cn=authproxy,ou=services
        - name: OPENLDAP_BIND_PW
          valueFrom:
            secretKeyRef:
              key: authproxy-password
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_DOMAIN
          value: {{ root_domain }}
        - name: OPENLDAP_HOST
{% if ldaps_address | default(False) %}
          value: {{ ldaps_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldaps_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldaps
{% else %}
          value: {{ ldap_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldap_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldap
{% endif %}
        - name: OPENLDAP_USERS_OBJECTCLASS
{% if alertmanager_do_fusion %}
          value: gosaAccount
{% else %}
          value: {{ alertmanager_ldap_user_objectclass }}
{% endif %}
        - name: PING_PATH
          value: ""
{% endif %}
        - name: PROXY_BACKEND_HOST
          value: 127.0.0.1
        - name: PROXY_BACKEND_PORT
          value: "9093"
        - name: PROXY_BACKEND_PROTO
          value: http
        - name: PROXY_HTTP_PORT
          value: "8080"
        - name: PROXY_PROTO
          value: http
        - name: PROXY_SERVER_NAME
          value: {{ alertmanager_fqdn }}
        - name: PUBLIC_PROTO
          value: https
        - name: TZ
          value: {{ timezone }}
        image: {{ (opsimages | json_query("[?name=='authproxy'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 30
          httpGet:
            httpHeaders:
            - name: Host
{% if alertmanager_do_lemon %}
              value: {{ alertmanager_fqdn }}
            path: /ping/
{% else %}
              value: stats
            path: /
{% endif %}
            port: 8080
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 8
        name: authproxy
        ports:
        - containerPort: 8080
        readinessProbe:
          httpGet:
            httpHeaders:
            - name: Host
{% if alertmanager_do_lemon %}
              value: {{ alertmanager_fqdn }}
            path: /ping/
{% else %}
              value: stats
            path: /
{% endif %}
            port: 8080
          initialDelaySeconds: 5
          periodSeconds: 20
          timeoutSeconds: 5
        resources:
          limits:
            cpu: "{{ authproxy_cpu_limit }}"
            memory: "{{ authproxy_memory_limit }}"
          requests:
            cpu: "{{ authproxy_cpu_request }}"
            memory: "{{ authproxy_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
{% if (alertmanager_do_ldap or alertmanager_do_lemon) and k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /etc/apache2/sites-enabled
          name: temp
          subPath: apache
        - mountPath: /etc/ldap
          name: ldapconf
        - mountPath: /usr/local/share/ca-certificates
          name: temp
          subPath: ca-certificates
        - mountPath: /etc/ssl/certs
          name: temp
          subPath: certs
        - mountPath: /usr/share/ca-certificates
          name: temp
          subPath: empty
{% if do_exporters %}
      - args:
{% if do_debugs %}
        - --log.level=debug
{% endif %}
        - --scrape_uri
        - http://stats:8080/server-status
        - --telemetry.address=:9113
        image: {{ (opsimages | json_query("[?name=='httpexporter'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 30
          httpGet:
            path: /
            port: 9113
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 3
        name: exporter
        ports:
        - containerPort: 9113
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% endif %}
{% elif alertmanager_do_oc %}
      - args:
        - -provider=openshift
        - -proxy-prefix=/oauth2
{% if oc_api_fqdn | default(False) %}
        - -login-url=https://{{ oc_api_fqdn }}/oauth/authorize
        - -redeem-url=https://kubernetes.default.svc/oauth/token
{% endif %}
        - -https-address=:8443
        - -http-address=
        - -email-domain=*
        - -upstream=http://127.0.0.1:9093
        - -tls-cert=/etc/tls/private/tls.crt
        - -tls-key=/etc/tls/private/tls.key
        - -client-id=system:serviceaccount:{{ namespace }}:{{ alertmanager_name }}
        - -client-secret-file=/var/run/secrets/kubernetes.io/serviceaccount/token
        - -cookie-secret-file=/etc/proxy/secrets/session_secret
        - -cookie-refresh=0
        - -cookie-expire=24h0m0s
        - -cookie-name=_oauth2_alertmanager
        - -skip-auth-regex=^/oauth/healthz
        image: {{ (opsimages | json_query("[?name=='oauthproxy'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 30
          initialDelaySeconds: 30
          tcpSocket:
            port: 8443
          periodSeconds: 20
          timeoutSeconds: 8
        name: authproxy
        ports:
        - containerPort: 8443
        readinessProbe:
          httpGet:
            path: /oauth/healthz
            port: 8443
            scheme: HTTPS
          initialDelaySeconds: 5
          periodSeconds: 20
          timeoutSeconds: 5
        resources:
          limits:
            cpu: "{{ oauthproxy_cpu_limit }}"
            memory: "{{ oauthproxy_memory_limit }}"
          requests:
            cpu: "{{ oauthproxy_cpu_request }}"
            memory: "{{ oauthproxy_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /etc/tls/private
          name: tls
        - mountPath: /etc/proxy/secrets
          name: session
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-monitoring
{% endif %}
{% if k8s_flavor == 'kubernetes' or rwo_needs_fsgroup | default(False) %}
      securityContext:
{% if rwo_needs_fsgroup | default(False) %}
        fsGroup: {{ rwo_needs_fsgroup }}
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
        runAsUser: {{ k8s_unprivileged_userid }}
{% endif %}
{% else %}
      securityContext: {}
{% endif %}
{% if not alertmanager_do_lemon and not alertmanager_do_ldap and alertmanager_do_oc %}
      serviceAccountName: {{ alertmanager_name }}
{% else %}
      serviceAccountName: default
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ alertmanager_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - name: config
        secret:
          secretName: {{ alertmanager_name }}
{% if alertmanager_do_lemon or alertmanager_do_ldap %}
      - configMap:
          name: {{ ldap_name | default('ldap') }}-config
        name: ldapconf
{% endif %}
{% if (alertmanager_do_ldap or alertmanager_do_lemon or (not (smtp_relay | default(False)) and smtps_address | default(False))) and k8s_flavor == 'kubernetes' %}
      - name: pkiconf
        projected:
          sources:
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if directory_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% if alertmanager_do_lemon or alertmanager_do_ldap %}
      - emptyDir: {}
        name: temp
{% elif alertmanager_do_oc %}
      - name: session
        secret:
          secretName: {{ prometheus_name }}-oauth
      - name: tls
        secret:
          secretName: {{ alertmanager_name }}-cert
{% endif %}
  updateStrategy:
    type: RollingUpdate
  volumeClaimTemplates:
  - metadata:
      name: data
    spec:
      accessModes: [ ReadWriteOnce ]
      resources:
        requests:
          storage: "{{ alertmanager_data_capacity }}"
{% if rwo_storage is defined %}
      storageClassName: {{ rwo_storage }}
{% endif %}
